#include "stdafx.h"
#include "StrConv.h"

//#include <windows.h>
//#include <winnls.h>
//#include <winbase.h>

//***********************************************
void Ansi2Wide(PCSTR szAnsi, PWSTR szWide)
{
	_ASSERTE(szAnsi);
	_ASSERTE(szWide);

	MultiByteToWideChar(CP_ACP, 0, szAnsi, -1, szWide, lstrlenA(szAnsi) + 1);
}

//***********************************************
PWSTR Ansi2Wide(PCSTR szAnsi)
{
	_ASSERTE(szAnsi);

	PWSTR szWide = new WCHAR[lstrlenA(szAnsi) + 1];

	MultiByteToWideChar(CP_ACP, 0, szAnsi, -1, szWide, lstrlenA(szAnsi) + 1);

	return szWide;
}

//***********************************************
void Ansi2Text(PCSTR szAnsi, PTSTR szText)
{
	_ASSERTE(szAnsi);
	_ASSERTE(szText);

#if defined(UNICODE) || defined(_UNICODE)
	MultiByteToWideChar(CP_ACP, 0, szAnsi, -1, szText, lstrlenA(szAnsi) + 1);
#else
	lstrcpyA(szText, szAnsi);
#endif
}

//***********************************************
PTSTR Ansi2Text(PCSTR szAnsi)
{
	_ASSERTE(szAnsi);

	PTSTR szText = new TCHAR[lstrlenA(szAnsi) + 1];

#if defined(_UNICODE) || defined(UNICODE)
	MultiByteToWideChar(CP_ACP, 0, szAnsi, -1, szText, lstrlenA(szAnsi) + 1);
#else
	lstrcpyA(szText, szAnsi);
#endif

	return szText;
}

//***********************************************
void Text2Ansi(PCTSTR szText, PSTR szAnsi)
{
	_ASSERTE(szText);
	_ASSERTE(szAnsi);

#if defined(UNICODE) || defined(_UNICODE)
	WideCharToMultiByte(CP_ACP, 0, szText, -1, szAnsi, lstrlenW(szText) + 1, NULL, NULL);
#else
	lstrcpyA(szAnsi, szText);
#endif
}

//***********************************************
PSTR Text2Ansi(PCTSTR szText)
{
	_ASSERTE(szText);

	PSTR szAnsi = new char[lstrlen(szText) + 1];

#if defined(_UNICODE) || defined(UNICODE)
	WideCharToMultiByte(CP_ACP, 0, szText, -1, szAnsi, lstrlenW(szText) + 1, NULL, NULL);
#else
	lstrcpyA(szAnsi, szText);
#endif

	return szAnsi;
}

//***********************************************
void Text2Wide(PCTSTR szText, PWSTR szWide)
{
	_ASSERTE(szText);
	_ASSERTE(szWide);

#if defined(UNICODE) || defined(_UNICODE)
	lstrcpyW(szWide, szText);
#else
	MultiByteToWideChar(CP_ACP, 0, szText, -1, szWide, lstrlenA(szText) + 1);
#endif
}

//***********************************************
PWSTR Text2Wide(PCTSTR szText)
{
	_ASSERTE(szText);

	PWSTR szWide = new WCHAR[lstrlen(szText) + 1];

#if defined(UNICODE) || defined(_UNICODE)
	lstrcpyW(szWide, szText);
#else
	MultiByteToWideChar(CP_ACP, 0, szText, -1, szWide, lstrlenA(szText) + 1);
#endif

	return szWide;
}

//***********************************************
void Wide2Ansi(PCWSTR szWide, PSTR szAnsi)
{
	_ASSERTE(szWide);
	_ASSERTE(szAnsi);

	WideCharToMultiByte(CP_ACP, 0, szWide, -1, szAnsi, lstrlenW(szWide) + 1, NULL, NULL);
}

//***********************************************
PSTR Wide2Ansi(PCWSTR szWide)
{
	_ASSERTE(szWide);

	PSTR szAnsi = new char[lstrlenW(szWide) + 1];

	WideCharToMultiByte(CP_ACP, 0, szWide, -1, szAnsi, lstrlenW(szWide) + 1, NULL, NULL);

	return szAnsi;
}

//***********************************************
void Wide2Text(PCWSTR szWide, PTSTR szText)
{
	_ASSERTE(szWide);
	_ASSERTE(szText);

#if defined(UNICODE) || defined(_UNICODE)
	lstrcpyW(szText, szWide);
#else
	WideCharToMultiByte(CP_ACP, 0, szWide, -1, szText, lstrlenW(szWide) + 1, NULL, NULL);
#endif
}

//***********************************************
PTSTR Wide2Text(PCWSTR szWide)
{
	_ASSERTE(szWide);

	PTSTR szText = new TCHAR[lstrlenW(szWide) + 1];

#if defined(UNICODE) || defined(_UNICODE)
	lstrcpyW(szText, szWide);
#else
	WideCharToMultiByte(CP_ACP, 0, szWide, -1, szText, lstrlenW(szWide) + 1, NULL, NULL);
#endif

	return szText;
}
